#ifndef BasicGEM
#define BasicGEM
#ifndef BasicSDL
#include "BasicSDL.h"
#endif
#ifndef	_DIRENT_H
#include <dirent.h>
#endif
#define FILES_MAX 1000
#define ALERTW 320
#define ALERTH 200
#define GEMMOUSEBUTTONUP 0
#define CFACE   0xafcfaf // kolor powierzchni
#define CUPPER  0xcfffcf // kolor jasny/górnej krawędzi
#define CLOWER  0x7faf7f // kolor ciemny/dolnej krawędzi
#define CTEXT   0x000000 // kolor tekstu
#define CTEXTBG 0xafffaf // kolor tła tekstu
#define CCURSOR 0xff0000 // kolor kursora tekstowego
#define CDIS    0x8fbf8f // kolor zblokowanego elementu
union BASSDLColor GEMColor[]={
{{255,255,255,127}},/* WHITE */
{{0,0,0,127}},/* BLACK */
{{255,0,0,127}},/* RED */
{{0,255,0,127}},/* GREEN */
{{0,0,255,127}},/* BLUE */
{{0,255,255,127}},/* CYAN */
{{255,255,0,127}},/* YELLOW */
{{255,0,255,127}},/* MAGENTA */
{{156,156,156,127}},/* LWHITE */
{{78,78,78,127}},/* LBLACK */
{{255,127,127,127}},/* LRED */
{{127,255,127,127}},/* LGREEN */
{{127,127,255,127}},/* LBLUE */
{{127,255,255,127}},/* LCYAN  */
{{255,255,127,127}},/* LYELLOW */
{{255,127,255,127}} /* LMAGENTA */
};
SDL_Texture*GEMScreen=0;
struct GEMBOX{
	char*Text;
	Uint8 State;	//1 Enabled | 2 Visible | 4 Select | 8 off | 16 radio | 32 xor
	Uint8 Type;	//0 brick, 1 text button, 2 P button, 10 box, 11 tekst line, 12 text box, 13 list box
	int x,y,w,h,n,s;
	SDL_Texture*P;};
#define GEMAlert(x,y,txt,sel,o,n) n=GEMMessage(x,y,txt,sel,o);
#define GEMBox(B,T,N,X,Y,W,H) {B.State=3;B.Type=T;B.Text=(char*)N;B.x=X;B.y=Y;B.w=W;B.h=H;B.P=NULL;B.n=0;B.s=0;}
#define GEMBoxClick(B) (MouseK?(MouseX<B.x+B.w && MouseX>=B.x && MouseY<B.y+B.h && MouseY>=B.y):0)
#define GEMBoxDraw(B) GEMDrawBox(B);
#define GEMBoxesDraw(B,n) GEMDrawBoxes(B,n);
#define GEMBoxRow(B,Y) ((Y-B.y-(B.h-B.h/GPR.h*GPR.h)/2)/GPR.h)
#define GEMColor(k) SDL_SetRenderDrawColor(SDLRenderer,GEMColor[k].SDL.r,GEMColor[k].SDL.g,GEMColor[k].SDL.b,GEMColor[k].SDL.a);
#define GEMFileSelect(t,Dir,m,df) GEMFileSelector(t,Dir,m,df);
#define GEMMenu(B,n,w,sel) sel=GEMWaitBoxClick(B,n,w);
#define GEMShow {SDL_SetRenderTarget(SDLRenderer,0);SDL_RenderCopy(SDLRenderer,GEMScreen,0,0);SDL_RenderPresent(SDLRenderer);}
#define GEMTextEdit(B) GEMEdit(B);
#define GEMWinDraw(x,y,w,h) GEMWindow(x,y,w,h);
void GEMDrawBox(struct GEMBOX B){
	Uint32 cu,cl,ct,cf;
	ct = B.State&1 ? CTEXT : CDIS;
	if(B.Type>9 && B.Type<20){cl=CUPPER;cu=CLOWER;cf=CTEXTBG;}
	else if(B.State&4){cu=CFACE;cl=CUPPER;cf=CLOWER;}
	else{cu=CUPPER;cl=CLOWER;cf=CFACE;}
	SDL_Rect r={B.x-1,B.y-1,B.w+2,B.h+2};
	Color(cf)
	if(B.Type<10) {if(B.n) Color(B.n) if(B.s) ct=B.s;}
	SDL_RenderFillRect(SDLRenderer,&r);
	Color(cu) Line(B.x,r.y,B.w,1) Line(r.x,B.y,1,B.h)
	Color(cl) Line(B.x,B.y+B.h,B.w,1) Line(B.x+B.w,B.y,1,B.h)
	If(B.Type<10)
		if(B.Text){GPColor(ct) GPrintAt(B.x+B.w/2-GPR.w*LenUTF(B.Text,0,STRLEN)/2,B.y+B.h/2-GPR.h/2,B.Text)}
		if(B.P){ImgColorMod(B.P,ct) PutImgSize(B.P,B.x,B.y,B.w,B.h)}
	Else
		GPColor(CTEXT) cu=B.w/GPR.w;cl=B.h/GPR.h;ct=(B.w-cu*GPR.w)/2;cf=(B.h-cl*GPR.h)/2;
		if(B.Type==11){GPR.x=B.x+ct;GPR.y=B.y+cf;SDLGPrint(B.Text,cu,1,B.x+B.w-GPR.w,WINDOWH,1);}
		if(B.Type==12){GPR.x=B.x+ct;GPR.y=B.y+cf;SDLGPrint(B.Text,cu*cl,1,B.x+B.w-GPR.w,WINDOWH,0);}
		if(B.Type==13){if(B.s>=0){Color(CLOWER) PRect(B.x,B.y+cf+B.s*GPR.h,B.w,GPR.h)}
			GPR.x=B.x+ct;GPR.y=B.y+cf;SDLGPrint(B.Text,cu,B.n,B.x+B.w-GPR.w,B.y+B.h-GPR.h,1);}
	EndIf
}
void GEMDrawBoxes(struct GEMBOX*B,int n){
	while(n)GEMDrawBox(B[--n]);
}
int GEMWaitBoxClick(struct GEMBOX*B,int n,int w){
	SDL_Event e;
	Uint32 windowID = SDL_GetWindowID(SDLWindow);
	WindowEvent=0;
	InKey=0;
	MouseK=MouseX=MouseY=0;
	int i,sel=-1;
	for(i=0;i<n;i++)if(B[i].State&4){
		if(B[i].State&16)sel=i;
		if(B[i].State&8)B[i].State&=~4;
	}
	while(!Quit && SDL_WaitEvent(&e)){
		switch(e.type){
		case SDL_MOUSEBUTTONDOWN:
			MouseX=e.button.x;MouseY=e.button.y;MouseK=e.button.button;if(e.button.clicks==2)MouseK|=32;
			If(MouseK==1||MouseK==33)
			  for(i=0;i<n;i++)if((B[i].State&3)==3 && PointInRect(MouseX,MouseY,B[i].x,B[i].y,B[i].w,B[i].h)){
				if(B[i].State&32) B[i].State^=4;else B[i].State|=4;
				if(sel!=i && B[sel].State&16 && B[i].State&16) B[sel].State&=~4;
				sel=i;Quit=2;}
			Else Quit=6;
			EndIf
			break;
#if GEMMOUSEBUTTONUP
		case SDL_MOUSEBUTTONUP:
			MouseX=e.button.x;MouseY=e.button.y;MouseK=e.button.button;MouseK|=16;
			Quit=3;
			break;
#endif
		case SDL_KEYDOWN:
/*			if(e.key.keysym.sym==SDLK_TAB){
				B[sel].State&=~4;while(!(B[sel=(sel+1)%n].State&3));B[sel].State|=4;}*/
			InKey=e.key.keysym.sym;
			Quit=4;
			break;
		case SDL_WINDOWEVENT:
			if(e.window.windowID==windowID) WindowEvent|=1<<e.window.event;
			if (w)Quit=5;
			break;
		case SDL_QUIT:Quit=1;}
	}
	Quit=Quit==1;return sel;
}
void GEMWindow(int x,int y,int w,int h){
	ColorC.BAS=CFACE; ColorRGBA(ColorC.SDL.r,ColorC.SDL.g,ColorC.SDL.b,255) PRect(x,y,w,h)
	ColorRGBA(0,0,0,255) Rect(x,y,w,h) Rect(x+1,y+1,w-2,h-2) Rect(x+4,y+4,w-8,h-8)
}
int GEMMessage(int x,int y,const char*txt,Uint8 sel,char*o){
	STRING odp;Let(odp,o)
	struct GEMBOX B[9];
	int n=0,ax=(WINDOWW-ALERTW)/2,ay=(WINDOWH-ALERTH)/2,ox=ax+ALERTW/2-strlen(strchr(o,'|')+1)*GPR.w/2;
	Target(0)
	GEMWindow(ax,ay,ALERTW,ALERTH);
	B[0].Text=strtok(odp,"|");
	if(o[0]!='|'){
		ColorRGBA(ColorB.SDL.r,ColorB.SDL.g,ColorB.SDL.b,ColorB.SDL.a) PCircle(WINDOWW/2,ay+30,20)
		SRC((o[0]-32)*GPR.sw,0,GPR.sw,GPR.sh) DST(WINDOWW/2-15,ay+15,32,32)
		GPColor(Color.BAS) PutImgRect(GPR.T,SRC,DST)
		B[n].Text=strtok(NULL,"|");}
	while(B[n].Text!=NULL){
		B[n].State=19;B[n].State|=4*(sel==n);B[n].Type=1;B[n].P=0;B[n].n=0;B[n].s=0;
		B[n].x=ox;B[n].y=ay+ALERTH-GPR.h-8;B[n].w=strlen(B[n].Text)*GPR.w+2;B[n].h=GPR.h+2;
		GEMDrawBox(B[n]);
		ox+=B[n].w+GPR.w-4;n++;
#if DEBUG
if(n>8) puts("GEMMessage: Too many answers.");
#endif
		B[n].Text=strtok(NULL,"|");}
	GPColor(CTEXT) GPR.x=ax+x;GPR.y=ay+y;SDLGPrint(txt,-1,1,ax+ALERTW-GPR.w,ay+ALERTH-GPR.h-8,0);
	ShowPage
	n=GEMWaitBoxClick(B,n,0);
	InKey=0;
	return n;
}
Uint8 GEMEdit(struct GEMBOX B){
	if(!(B.State&3))return 0;
	int i,start=0,len=Len(B.Text),cpos=0,blen,bwlen=B.w/GPR.w;
	int p,start2=0,len2=LenUTF(B.Text,0,len),cpos2=0;
	int bhlen=B.h/GPR.h,px=(B.w-bwlen*GPR.w)/2,py=(B.h-bhlen*GPR.h)/2;
	char*t=B.Text,*pt;
	static SDL_Rect CSRC={740,1,1,6};
	if(B.s){cpos=len;cpos2=len2;}
	blen=bwlen;if(B.Type==12)blen*=bhlen;
	SDL_Event e;
	SDL_StartTextInput();
	while(!Quit && SDL_WaitEvent(&e)){
		Target(GEMScreen)
		switch(e.type){
		case SDL_MOUSEBUTTONDOWN:
			if(PointInRect(e.button.x,e.button.y,B.x,B.y,B.w,B.h)){
				p=(e.button.x-B.x)/GPR.w;if(B.Type==12)p+=(e.button.y-B.y)/GPR.h*bwlen;
				cpos2=p+start2;
				cpos=LenChr(B.Text,start,p)+start;}
			else Quit=2;
			break;
		case SDL_KEYDOWN:
			switch(e.key.keysym.sym){
			case SDLK_RETURN:
			case SDLK_KP_ENTER:Quit=3;break;
			case SDLK_LEFT:if(cpos){cpos-=(B.Text[cpos-1]&128)?2:1;cpos2--;}break;
			case SDLK_RIGHT:if(cpos<len){cpos+=(B.Text[cpos]&128)?2:1;cpos2++;}break;
			case SDLK_HOME:cpos=0;cpos2=0;break;
			case SDLK_END:cpos=len;cpos2=len2;break;
			case SDLK_DELETE:if(cpos<len){p=(B.Text[cpos]&128)?2:1;strcpy(&B.Text[cpos],&B.Text[cpos+p]);len-=p;len2--;}break;
			case SDLK_BACKSPACE:if(cpos){p=(B.Text[cpos-1]&128)?2:1;strcpy(&B.Text[cpos-p],&B.Text[cpos]);len-=p;cpos-=p;len2--;cpos2--;break;}
			case SDLK_v:if(SDL_GetModState()&KMOD_CTRL){pt=SDL_GetClipboardText();Let(B.Text,pt) SDL_free(pt);len=Len(B.Text);cpos=len;len2=LenUTF(B.Text,0,len);cpos2=len2;break;}
			case SDLK_x:if(SDL_GetModState()&KMOD_CTRL){SDL_SetClipboardText(B.Text);B.Text[0]=0;len=0;cpos=0;len2=0;cpos2=0;break;}
			case SDLK_c:if(SDL_GetModState()&KMOD_CTRL)SDL_SetClipboardText(B.Text);
			}break;
		case SDL_TEXTINPUT:
			p=Len(e.text.text);
			if(p+len<=STRLEN){
				for(i=len;i>=cpos;i--)B.Text[i+p]=B.Text[i];
				memmove(&B.Text[cpos],e.text.text,p);len+=p;cpos+=p;p=LenUTF(e.text.text,0,p);len2+=p;cpos2+=p;}
			break;
		case SDL_QUIT:Quit=1;
		}
	if(cpos2<blen/2)start=0;
	else if(len2-cpos2<=blen/2)start=len+LenChr(B.Text,len-1,-blen);
	else start=cpos+LenChr(B.Text,cpos-1,-blen/2);
	start2=cpos2-LenUTF(B.Text,start,cpos-1);
	B.Text=&B.Text[start]; GEMDrawBox(B); B.Text=t;
	p=cpos2-start2-1;
	if(B.Type==11) DST(B.x+px+(p+1)*GPR.w-1,B.y+py,2,GPR.h)
	else DST(B.x+px+p%bwlen*GPR.w+GPR.w-1,B.y+py+p/bwlen*GPR.h,2,GPR.h)
	GPColor(CCURSOR) PutImgRect(BASFont,CSRC,DST)
	if(GEMScreen)GEMShow else ShowPage
	}
  B.State&=~4;StopTextInput;Quit=Quit==1;return Quit;  
}
int DIRfileCmp(const STRING*a,const STRING*b){
	if(*a[0]==127&&*b[0]!=127)return -1;
	if(*b[0]==127&&*a[0]!=127)return 1;
	return strcmp(*a,*b);
}
int DIRarray(char*patch,char*mask,STRING*DIRfile){
	int n=0,len=Len(patch)-1;
	struct dirent*plik;DIR*dir;
	STRING fstart="",fend="",lfend="";
	char*p,*p2;
	Colors(-1,255)
	If((dir=opendir(patch)))
		if(patch[len]!='/' && patch[len]!='\\')	Add(patch,"/")
		else patch[len]='/';
	Else perror("opendir");GEMMessage(ALERTW/2-7*GPR.w,ALERTH/2,"OPEN DIR ERROR",0,"!|OK");return -1;
	EndIf
	If((p=strchr(mask,'*')))
		strncat(fstart,mask,p-mask);
	ElseIf((p=strchr(mask,'.')))
		strncat(fstart,mask,p-mask);
	Else
		Let(fstart,mask)
	EndIf
	If((p=strrchr(mask,'.')))
		If((p2=strrchr(p,'*')))
			strncat(fend,p,p2-p);
		Else
			Let(fend,p)
		EndIf
		if(fend[1]==0)fend[0]=0;
	EndIf
	len=Len(fstart);
	Let(lfend,fend) Lower(lfend)
	While((plik=readdir(dir)))
		If(plik->d_name[0]=='.')
			if(plik->d_name[1]==0)continue;
			if(plik->d_name[2]==0 && plik->d_name[1]=='.')continue;
		EndIf
		if(plik->d_type==DT_REG && strncmp(plik->d_name,fstart,len)==0 && (strstr(plik->d_name,fend)||strstr(plik->d_name,lfend))){Let(DIRfile[n],plik->d_name) n++;}
		if(plik->d_type==DT_DIR){DIRfile[n][0]=127;Let(&DIRfile[n][1],plik->d_name) n++;}
		if(n>=FILES_MAX){GEMMessage(ALERTW/2-8*GPR.w,ALERTH/2,"MAX FILES REACHED",0,"!|OK");break;}
	Wend
	closedir(dir);
	SDL_qsort(DIRfile,n,STRLEN+1,(int(*)(const void*,const void*))DIRfileCmp);
	return n;
}
void DrawFS(struct GEMBOX*B,int BXS,char*t){
	Target(GEMScreen)
	GEMWindow(0,0,WINDOWW,WINDOWH);
	GPColor(CTEXT)	GPrintAt((WINDOWW-Len(t)*GPR.w)/2,6,t)
	GPrintAt(8,8+GPR.h,"Dir:") GPrintAt(WINDOWW/2,8+GPR.h,"Sel:")
	GEMDrawBoxes(B,BXS);
	GPColor(CTEXT) SRC(497,1,5,6) DST(B[0].x+3,B[0].y+B[0].h*.5-31,10,12) PutImgRect(BASFont,SRC,DST)
	DST.y+=50;PutImgREF(BASFont,SRC,DST,0,2)
	GEMShow
}
int GEMFileSelector(char*t,char*Dir,char*m,char*df){
	STRING DIRfile[FILES_MAX],patch,cdf,mask,p;
	char*c,*home=SDL_GetBasePath();
	Let(mask,m) Let(cdf,df)
	if(Dir[0]==0) Let(patch,home) else Let(patch,Dir)
	int BXS=10,n=DIRarray(patch,mask,DIRfile),sel=3,fstart=0;
	if(n==-1)return n;
	if(!GEMScreen) CreateImg(GEMScreen,WINDOWW,WINDOWH)
	struct GEMBOX B[BXS];
	GEMBox(B[0],0,0,WINDOWW*.75+8,20+GPR.h*3,16,WINDOWH-28-GPR.h*3)
	GEMBox(B[1],11,mask,4+GPR.h*4,8+GPR.h,WINDOWW/2-GPR.h*4-8,GPR.h)
	GEMBox(B[2],11,patch,6,16+GPR.h*2,WINDOWW-12,GPR.h)
	GEMBox(B[3],11,df,WINDOWW/2+GPR.h*4,8+GPR.h,WINDOWW/2-GPR.h*4-6,GPR.h)
	GEMBox(B[4],13,DIRfile,6,20+GPR.h*3,WINDOWW*.75,WINDOWH-28-GPR.h*3) B[4].s=-1;B[4].n=n;
	GEMBox(B[5],1,"UP",WINDOWW-GPR.w*6-6,20+GPR.h*3,GPR.w*6,GPR.h)
	GEMBox(B[6],1,"BASE",WINDOWW-GPR.w*6-6,WINDOWH*.5,GPR.w*6,GPR.h)
	GEMBox(B[7],1,"ROOT",WINDOWW-GPR.w*6-6,WINDOWH*.5+GPR.w+4,GPR.w*6,GPR.h)
	GEMBox(B[8],1,"OK",WINDOWW-GPR.w*6-6,WINDOWH-GPR.h*2-10,GPR.w*6,GPR.h)
	GEMBox(B[9],1,"CANCEL",WINDOWW-GPR.w*6-6,WINDOWH-GPR.h-6,GPR.w*6,GPR.h)
	int bhlen=B[4].h/GPR.h;
	DrawFS(B,BXS,t);GEMEdit(B[3]);
	Do
		B[4].n=n-fstart;
		DrawFS(B,BXS,t);
		WaitMouseU
		B[sel].State&=~4;
		DrawFS(B,BXS,t);
		sel=GEMWaitBoxClick(B,BXS,0);
		B[4].s=-1;
		Select(sel)
		Case 2:	//dir name
			Let(p,patch)
			GEMEdit(B[2]);
			n=DIRarray(patch,mask,DIRfile);
			if(n<0){Let(patch,p) n=DIRarray(patch,mask,DIRfile);}
			fstart=0;B[4].Text=(char*)DIRfile;
		Case 1:	//mask
			GEMEdit(B[1]);
			n=DIRarray(patch,mask,DIRfile);fstart=0;B[4].Text=(char*)DIRfile;
		Case 3: GEMEdit(B[3]);	//f. name
		Case 7:	//root
			Let(patch,"/")
			n=DIRarray(patch,mask,DIRfile);fstart=0;B[4].Text=(char*)DIRfile;
		Case 4:	//dir box
			sel=GEMBoxRow(B[4],MouseY)+fstart;
			if(sel>=n)break;
			If(DIRfile[sel][0]==127)	//open folder
				Let(p,patch) Add(p,&DIRfile[sel][1]) 
				If((sel=DIRarray(p,mask,DIRfile))!=-1);
					n=sel;
					Let(patch,p)
					fstart=0;
					B[4].Text=(char*)DIRfile;
				EndIf
				break;
			Else	//change f. name
				Let(df,DIRfile[sel])
				B[4].s=sel-fstart;
				if(!(MouseK&32))break;	//2-click: OK
			EndIf
		case 8:	//OK
			Let(cdf,df) Let(df,patch) Add(df,cdf)
			return 0;
		Case 9:	//cancel
			Let(df,cdf)
			return -1;
		Case 5:	//up
			sel=Len(patch);
			patch[sel-1]=0;
			c=strrchr(patch,'/');
			If((c=strrchr(patch,'/')))
				patch[c-patch+1]=0;
				n=DIRarray(patch,mask,DIRfile);
				fstart=0;B[4].Text=(char*)DIRfile;
			Else
				patch[sel-1]='/';
			EndIf
			sel=5;
		Case 0:	//scroll
			While(n>bhlen && MouseK)
				fstart+=(MouseY-B[0].y-B[0].h/2)/GPR.h;
				if(fstart>n-bhlen)fstart=n-bhlen;
				if(fstart<0)fstart=0;
				B[4].Text=(char*)&DIRfile[fstart];
				DrawFS(B,BXS,t);
				Pause(50)
				GetEvents
			Wend
			B[0].State&=~4;
		Case 6:	//base
			n=DIRarray(home,mask,DIRfile);
			Let(patch,home)
			fstart=0;B[4].Text=(char*)DIRfile;
		EndSelect
		if(InKey==SDLK_RETURN||InKey==SDLK_KP_ENTER)return 0;
	Until(Quit)
	return sel;
}
#endif
